// TEST_PHASE 18
/* Test FS, ten docasne slinkovan s kernelem */
/* FILE CREATION, COPYING AND VERIFICATION TEST */
/* (creat,open,close,seek,read,write) */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "COMMON\stat.h"

#include "test\kprintf.h"

#include "FS\COMMON\fsconst.h"
#include "FS\COMMON\fsmes.h"

#define PROC1 (NR_TASKS+NR_SERVS)


#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m;

void proc1(void) {

#define TEST_FILE "/file.seek"

 int fd,result;
 static unsigned char c;
 long l;

 kprintf(0,0,2,"FS TEST: seek test");

 m.m_type = C_CREAT;
 m.fs_name = TEST_FILE;
 m.fs_mode = I_REGULAR | 0777;

 send_recv(FS,m);
 fd=m.fs_fd;
 kprintf(1,0,7,"File handle: %u",fd);

 if (fd>=0) {

  m.m_type = C_LSEEK;
  m.fs_fd1=fd;
  m.fs_offset1=530433L;
  m.fs_whence=0; // from the begginning of the file
  send_recv(FS,m);
  kprintf(2,0,7,"Seek() result: %l",m.fs_pos1);

  for (l=0; l<1024L; l++) {
   m.m_type = C_WRITE;
   m.fs_fd = fd;
   m.fs_buffer=&c;
   m.fs_nbytes=1;
   m.fs_seg=D;
   send_recv(FS,m);

   result=m.fs_errcode;
   if (result<0) {
	   kprintf(3,0,5,"Write error: %u",result);
   }
   c++;
  }


  m.m_type = C_CLOSE;
  m.fs_fd = fd;
  send_recv(FS,m);
  kprintf(3,0,7,"Close result: %u",m.fs_errcode);
 }
  else kprintf(3,0,7,"Exiting test");

 m.m_type = C_SYNC;
 send_recv(FS,m);

 /* end with endless loop (the process must not exit, otherwise
    IP (PC) would get to some random place */

 while(1);
}

