// TEST_PHASE 2
// Totez jako TEST_PHASE 1, ale navic test schopnosti CLOCK tasku vyvolavat
// alarmy (alespon pro tasky). Tim se soucasne otestuje (aspon castecne) */
// zpracovani tiku hodin clock taskem.
// Funkce se projevuje pohybem tocitka, ktere periodicky meni barvu
// (ke zmene atributu dochazi v periodicky planovane alarm funkci)
// Written by P.G.

// MUSI BYT NASMEROVANO INT 08

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "clock\h_clock.h"

/* v inicialni fronte planovace v tomto poradi */
#define TASK1 2
#define TASK2 3
#define TASK3 4

#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m1,m2,m3,am1,am2,am3;

// alarm fce bezi v kontextu clock tasku
void task1_alarm_func(int nanic) {
 send(TASK1,m1);
}

void task1(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2+1); // atribut
 do {
   am1.m_type=SET_ALARM;
   am1.CLOCK_PROC=TASK1;
   am1.FUNC=(sighandler_t) task1_alarm_func;
   am1.NEW_TIME=1;
   send_recv(CLOCK,am1);
   if (am1.RET_ERROR_CODE!=OK) {
     char far* p=(char far*) MK_FP(0xb800,6*80*2+42*2);
     *p='!';
   }
   receive(CLOCK,m1); // alarm fce bezi v kontextu clock tasku
   // odsud se dostanu az po 2 sekundach
   *pos=*pos ^ 0x40; // zmena atributu co 2 s
 } while(1);
}

void task2(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2);
 do {
   *pos='|';
   send(TASK3,m2);
   receive(TASK3,m2);
 } while(1);
}

void task3(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2);
 do {
   receive(TASK2,m3);
   *pos='-';
   send(TASK2,m3);
 } while(1);
}

