// TEST_PHASE 25
/* Test FS, ten docasne slinkovan s kernelem */
/* mknod(), zapis */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "COMMON\stat.h"

#include "test\kprintf.h"
#include "test\exitor.h"

#include "FS\COMMON\fsconst.h"
#include "FS\COMMON\fsmes.h"
#include "LIB\include\string.h"

#define PROC1 (NR_TASKS+NR_SERVS)


#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m;

void proc1(void) {

 int fd,result,i;
 int line=1,col=0;
 char introText[]="Ahoj blboune !\nJsem tvuj oblibeny OS TUOX\nNapis neco, ja to opisu ('quit' ukonci)\n";
 static char buf[80];


#define SPEC_FILE "/tty5"

 m.m_type = C_MKNOD;
 m.fs_name = SPEC_FILE;
 m.fs_mode = I_CHAR_SPECIAL | 0777;
 m.fs_major_minor = 256*TTY+0;
 send_recv(FS,m);

 kprintf(line++,0,7,"mknod() error code: %i",m.fs_errcode);

 m.m_type = C_OPEN;
 m.fs_name = SPEC_FILE;
 m.fs_mode = S_IREAD | S_IWRITE;

 send_recv(FS,m);
 fd=m.fs_fd;
 kprintf(line++,0,7,"File handle: %u",fd);

 if (fd>=0) {
  for (i=0; i<sizeof(introText); i++) {
   m.m_type = C_WRITE;
   m.fs_fd = fd;
   m.fs_buffer=introText+i;
   m.fs_nbytes=1;
   m.fs_seg=D;
   send_recv(FS,m);
   result=m.fs_errcode;
   if (result<0) {
	   kprintf(line++,0,5,"write() error: %i",result);
	   break;
   }
  }
  do {
   m.m_type = C_READ;
   m.fs_fd = fd;
   m.fs_buffer=buf;
   m.fs_nbytes=80;
   m.fs_seg=D;
   send_recv(FS,m);
   result=m.fs_errcode;
   if (result>0) {
     buf[result]=0;
     m.m_type = C_WRITE;
     m.fs_fd = fd;
     m.fs_buffer=buf;
     m.fs_nbytes=result;
     m.fs_seg=D;
     send_recv(FS,m);
   }
  } while (result>0 && strcmp(buf,"quit\n"));

  m.m_type = C_CLOSE;
  m.fs_fd = fd;
  send_recv(FS,m);
  kprintf(line++,0,7,"close() result: %i",m.fs_errcode);
 }

 m.m_type = C_SYNC;
 send_recv(FS,m);

 returnToDOS();
}



void proc2(void) {

}