// TEST_PHASE 67
/* Test MM, ten docasne slinkovan s kernelem */
/* test exit, wait (spolu s fork, aby bylo co nicit :-) ) */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "test\kprintf.h"
#include "test\exitor.h"
#include "mm\mm.h"

static message m;

int getpid(int* pid, int* ppid) {
 m.m_type = C_GETPID;
 send_recv(MM,m);
 if (m.MM_ERRORNO==0) { *pid=m.MM_GPID; *ppid=m.MM_GPPID; }
 return m.MM_ERRORNO;
}

#define CHILD_NUM 4
void proc1(void) {
 int pid,ppid,err;
 char tocitko[]={'|','/','-','|','/','-','\\'};
 unsigned int i,t;
 unsigned long k;

 if ((err=getpid(&pid,&ppid))!=0) {
  kprintf(1,0,7,"parent: getpid() error: %i ",err);
  returnToDOS();
 }

 kprintf(1,0,7,"parent: pid=%u, ppid=%u",pid,ppid);

 for (i=0; i<CHILD_NUM; i++) {
   m.m_type = C_FORK;
   send_recv(MM,m);
   if (m.MM_ERRORNO!=0) {
      kprintf(2+i,0,7,"parent: fork #%i error: %i",i,m.MM_ERRORNO);
      returnToDOS();
    }

   pid=m.MM_FORKEDCHILD;
   if (pid==0) {
     /* vetev ditete */
     if ((err=getpid(&pid,&ppid))!=0)
      kprintf(2+i,0,7,"child #:%i: getpid() error: %i ",i,err);
     else {
       kprintf(2+i,0,7,"child #:%i is starting - pid %u, ppid %u",i,pid,ppid);
       /* tocitkem otocime (i+1)*10000-krat a pak konec */
       k=(i+1)*50000;
       while(k--) {
	for (t=0; t<7; t++)
	 kprintf(2+i,60,7,"%c",tocitko[t]);
       }

       m.m_type = C_EXIT;
       m.MM_EXITSTATUS=i*2;
       send_recv(MM,m);
     }
   }
 }
 kprintf(9,0,7,"All %i childs started, waiting until they exit",i);

 i=11;
 do {
   m.m_type = C_WAITPID;
   m.MM_WAITFOR=-1;
   m.MM_WAITOPT=0;
   send_recv(MM,m);
   if (m.MM_ERRORNO!=0) kprintf(i,0,7,"wait() error: %i",m.MM_ERRORNO);
    else kprintf(i++,0,7,"wait(): exited PID: %u, exit status: %u, termination status: %u",m.MM_EXITEDPID,m.MM_EXITVALUE & 0xFF, (m.MM_EXITVALUE >> 8) & 0xff);
 } while (i<11+CHILD_NUM);

 returnToDOS();
}

