// TEST_PHASE 73
/* Test MM, ten docasne slinkovan s kernelem */
/* test exec() */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "test\kprintf.h"
#include "test\exitor.h"
#include "mm\mm.h"
#include "COMMON\signal.h"

#include "LIB/process/execv.c"

static message m;
static unsigned char attr,r,c,a,r1,c1,a1;


int _getpid(int* pid, int* ppid) {
 m.m_type = C_GETPID;
 send_recv(MM,m);
 if (m.MM_ERRORNO==0) { *pid=m.MM_GPID; *ppid=m.MM_GPPID; }
 return m.MM_ERRORNO;
}

char tocitko[]={'|','/','-','|','/','-','\\'};

char* _argv[]={ "arg1","arg2","arg3",0 };
char* _env[]={ "envvar1=value1","envvar2=value2",0 };

void proc1(void) {
 int pid,ppid,err;

 unsigned int i,t;
 unsigned long k;

 if ((err=_getpid(&pid,&ppid))!=0) {
  kprintf(1,0,7,"parent: getpid() error: %i ",err);
  returnToDOS();
 }

 kprintf(1,0,7,"parent: pid=%u, ppid=%u",pid,ppid);

 m.m_type = C_FORK;
 send_recv(MM,m);
 if (m.MM_ERRORNO!=0) {
   kprintf(2,0,7,"parent: fork #%i error: %i",i,m.MM_ERRORNO);
   returnToDOS();
 }

 pid=m.MM_FORKEDCHILD;
 if (pid==0) {
     /* vetev ditete */
     if ((err=_getpid(&pid,&ppid))!=0) {
      kprintf(2,0,7,"child #:%i: getpid() error: %i ",i,err);
      returnToDOS();
     }
     else {

      err=execve("TESTEXE",_argv,_env);
      kprintf(2,0,7,"execve() error: %i", err);
     }
   }
  else {
   /* vetev rodice */
    while(1) for (t=0; t<7; t++) {
     writeOneChar(1,60,7,tocitko[t]);
    }
  }
}

