/*****************************************************************************/
/*                                                                           */
/*                   Interrupts to be hooked by bootstrap                    */
/*                                                                           */
/*****************************************************************************/

void s_call (void);	      /* 31h */
void clock_int ();	      /* 08h */
void unexpected_int (void);   /* all unused interrupts */

void tty_int ();	      /* 9h */
void hdd_int ();	      /* 0eh */
void floppy_int(void);	      /* 06h */
void rs232_1_int(void);       /* 0ch */
void rs232_2_int(void);       /* 0bh */

/* unused in current version of HDD driver */
void ide_1_int(void);
void ide_2_int(void);
