;==========================================================================
;
;   Soubor: C0S.ASM - startup kod pro programy pro TUOX
;   Autor: Zdenek SAWA, l93008
;   E-mail: Zdenek.Sawa.fei.@vsb.cz
;   Do predmetu: Operacni systemy                   Semestr: letni 1997
;
;==========================================================================

; P.G.: Poradi segmentu v image: kod, data, BSS (neinicializovana data)

		locals


_TEXT           SEGMENT BYTE PUBLIC 'CODE'
		ENDS
_DATA           SEGMENT PARA PUBLIC 'DATA'
		ENDS
_CONST          SEGMENT WORD PUBLIC 'CONST'
		ENDS
_BSS            SEGMENT WORD PUBLIC 'BSS'
		ENDS
_BSSEND         SEGMENT BYTE PUBLIC 'BSSEND'
		ENDS



DGROUP GROUP _DATA, _CONST, _BSS, _BSSEND


		ASSUME CS:_TEXT, DS:DGROUP

extrn           _main: NEAR
extrn           _exit: NEAR


_TEXT           SEGMENT


STARTX          PROC NEAR

		jmp short @@begin
@@info:         nop
		nop

		db 'TUOX'

	; doplnil P.G.: Symboly jsou potrebne pro zjisteni velikosti
	; segmentu jadra pri ladeni v podobe EXE

		IFDEF EXE
k_dgroup	label WORD
		PUBLIC k_dgroup
		ENDIF
		dw DGROUP

		IFDEF EXE
k_bdata		label WORD
		ENDIF
		dw offset DGROUP: bdata@

		IFDEF EXE
k_edata		label WORD
		ENDIF
		dw offset DGROUP: edata@

@@begin:

	; doplnil P.G., pro spousteni  kernelu jako DOS EXE
	; definovat symbol EXE
	IFDEF EXE
	       mov ax,DGROUP
	       mov ds,ax
	       mov ss,ax
	       mov ax,0FFE0h ; stack main() kernelu - pozdeji se prepise
			     ; je pod vrcholem zasobniku pro testovaci proc1
	       mov sp,ax
	ENDIF

		call _main
		push ax
		call _exit

STARTX          ENDP


_TEXT           ENDS


_BSS            SEGMENT
bdata@          label   byte
		ENDS

_BSSEND         SEGMENT
edata@          label   byte
		ENDS


		END STARTX

