// TEST_PHASE 1
// Test scheduleru: tri stridajici se tasky, rizeni si vzajemne predavaji
// zasilanim zprav. Kazdy vytiskne na danou pozici jednu fazi "tocitka" [|/-],
// stridanim tasku vznika iluze pohybu.
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"

/* v inicialni fronte planovace v tomto poradi */
#define TASK1 2
#define TASK2 3
#define TASK3 4

#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m1,m2,m3;

void task1(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2);
 do {
   *pos='|';
   receive(TASK3,m1);
   send(TASK2,m1); // chodi to i kdyz je zde (a ve vsech receive() ) ANY
 } while(1);
}

void task2(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2);
 do {
   *pos='/';
   receive(TASK1,m2);
   send(TASK3,m2);
 } while(1);
}

void task3(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2);
 do {
   *pos='-';
   send(TASK1,m3);
   receive(TASK2,m3);
 } while(1);
}

