// TEST_PHASE 24
/* Test FS, ten docasne slinkovan s kernelem */
/* test time,stime,tims */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "COMMON\stat.h"
#include "test\kprintf.h"

#include "FS\COMMON\fsconst.h"
#include "FS\COMMON\fsmes.h"
#include "FS\CACHE\buf.h"

#include "systask\syst_pub.h"

static message m;
int line=1;

void proc1(void) {

 long l,x;
 static time_struct ts;

 m.m_type = C_TIME;
 send_recv(FS,m);
 kprintf(line++,0,7,"Start of program: real time is: %l s, %l ms",m.fs_time_s,m.fs_time_ms);


 for (l=0; l<1000000L; l++) { x++; }

 m.m_type = C_TIME;
 send_recv(FS,m);
 kprintf(line++,0,7,"After some processing: real time is: %l s, %l ms",m.fs_time_s,m.fs_time_ms);

 m.m_type = C_TIMES;
 m.fs_buf =(char*) &ts;
 send_recv(FS,m);
 kprintf(line++,0,7,"tims() error code: %i",m.fs_errcode);
 kprintf(line++,0,7,"user_time: %l, sys_time: %l, child_utime: %l, child_stime: %l",
  ts.user_time,ts.sys_time,ts.child_user_time,ts.child_sys_time);

 m.m_type = C_STIME;
 m.fs_time_s+=10000;
 send_recv(FS,m);
 kprintf(line++,0,7,"stime() error code: %i",m.fs_errcode);

 m.m_type = C_TIME;
 send_recv(FS,m);
 kprintf(line++,0,7,"After stime(): real time is: %l s, %l ms",m.fs_time_s,m.fs_time_ms);

 kprintf(line++,0,7,"Some additional processing");
 for (l=0; l<10000000L; l++) { x++; }

 m.m_type = C_TIMES;
 m.fs_buf =(char*) &ts;
 send_recv(FS,m);
 kprintf(line++,0,7,"tims() error code: %i",m.fs_errcode);
 kprintf(line++,0,7,"user_time: %l, sys_time: %l, child_utime: %l, child_stime: %l",
  ts.user_time,ts.sys_time,ts.child_user_time,ts.child_sys_time);


 /* end with endless loop (the process must not exit, otherwise
    IP (PC) would get to some random place */

 while(1);
}

